/******************************************************************************

FILE:  mrt_error.h

PURPOSE:  Error codes for ErrorHandler

HARDWARE AND/OR SOFTWARE LIMITATIONS:  
  None

PROJECT:    MODIS Reprojection Tool

NOTES:
  Messages are generated by a static char array located
  in mrt_error.c
  
******************************************************************************/

#define NUM_ERROR_CODES                 104

#define MRT_NO_ERROR                     0

#define ERROR_GENERAL                   -1
#define ERROR_ASSERT                    -2
#define ERROR_ENV                       -3
#define ERROR_MEMORY                    -4
#define ERROR_THREAD                    -5
#define ERROR_SEMAPHORE                 -6
#define ERROR_MUTEX                     -7

#define ERROR_OPEN_INPUTPAR 		-10
#define ERROR_READ_INPUTPAR             -11

#define ERROR_OPEN_OUTPUTPAR		-12
#define ERROR_WRITE_OUTPUTPAR		-13

#define ERROR_OPEN_INPUTIMAGE 		-14
#define ERROR_READ_INPUTIMAGE		-15

#define ERROR_OPEN_OUTPUTIMAGE 		-16
#define ERROR_WRITE_OUTPUTIMAGE		-17

#define ERROR_OPEN_INPUTHEADER		-18
#define ERROR_READ_INPUTHEADER		-19

#define ERROR_OPEN_OUTPUTHEADER		-20
#define ERROR_WRITE_OUTPUTHEADER	-21

#define ERROR_NOCOMMANDLINE_ARGUMENT    -22
#define ERROR_NOPARAMFILE_NAME          -23
#define ERROR_UNKNOWN_ARGUMENT          -24
#define ERROR_INPUT_EXTENSION           -25
#define ERROR_OUTPUT_EXTENSION          -26
#define ERROR_RESAMPLE_TYPE             -27
#define ERROR_PROJECTION_TYPE           -28

#define ERROR_INPUTNAME_FIELD           -29
#define ERROR_SPECTRALSUB_FIELD         -30
#define ERROR_SPATIALSUB_FIELD          -31
#define ERROR_OUTPUTNAME_FIELD          -32
#define ERROR_RESAMPLE_FIELD            -33
#define ERROR_OUTPROJECTION_FIELD       -34
#define ERROR_OUTPROJPARAMS_FIELD       -35

#define ERROR_DATA_TYPE                 -36

#define ERROR_PROJPARAMS_FIELD          -37
#define ERROR_PROJPARAMS_VALUE          -38
#define ERROR_READ_CORNERS              -39
#define ERROR_NBANDS_FIELD              -40
#define ERROR_NBANDS_VALUE              -41
#define ERROR_BANDNAMES_FIELD           -42
#define ERROR_BANDNAMES_VALUE           -43
#define ERROR_DATATYPE_FIELD            -44
#define ERROR_DATATYPE_VALUE            -45
#define ERROR_NLINES_FIELD              -46
#define ERROR_NLINES_VALUE              -47
#define ERROR_NSAMPLES_FIELD            -48
#define ERROR_NSAMPLES_VALUE            -49
#define ERROR_PIXELSIZE_FIELD           -50
#define ERROR_PIXELSIZE_VALUE           -51
#define ERROR_MINVALUE_FIELD            -52
#define ERROR_MINVALUE_VALUE            -53
#define ERROR_MAXVALUE_FIELD            -54
#define ERROR_MAXVALUE_VALUE            -55
#define ERROR_FILLVALUE_FIELD           -56
#define ERROR_FILLVALUE_VALUE           -57
#define ERROR_BANDCOUNT                 -58
#define ERROR_NO_BANDS                  -59
#define ERROR_UTMZONE_FIELD             -60
#define ERROR_UTMZONE_VALUE             -61
#define ERROR_DATUM_FIELD		-62
#define ERROR_DATUM_VALUE               -63
#define ERROR_SPATIAL_SUBSET_TYPE       -64
#define ERROR_BYTEORDER_FIELD           -65
#define ERROR_BYTEORDER_VALUE           -66

#define ERROR_PROJECTION                -70
#define ERROR_OPEN_DATUMFILE 		-71
#define ERROR_OPEN_SPHEREFILE 		-72
#define ERROR_PROJECTION_MATH 		-73

#define ERROR_GCTP_PTBREAK              -74
#define ERROR_GCTP_OUTNAME              -75
#define ERROR_GCTP_TRANSFAIL            -76
#define ERROR_GCTP_CONVERGE             -77
#define ERROR_GCTP_ROBITER              -78
#define ERROR_GCTP_INVITER              -79
#define ERROR_GCTP_INDATA               -80
#define ERROR_GCTP_BADDMS               -81
#define ERROR_GCTP_INUNIT               -82
#define ERROR_GCTP_INSYS                -83
#define ERROR_GCTP_INCODE               -84
#define ERROR_GCTP_INZONE               -85
#define ERROR_GCTP_INF                  -86
#define ERROR_GCTP_LATITER              -87
#define ERROR_GCTP_OUTUNIT              -88
#define ERROR_GCTP_OUTSYS               -89
#define ERROR_GCTP_OUTCODE              -90
#define ERROR_GCTP_OUTZONE              -91
#define ERROR_GCTP_POLAR                -92
#define ERROR_GCTP_PTPROJ               -93
#define ERROR_GCTP_PTCIRC               -94
#define ERROR_GCTP_50ITER               -95
#define ERROR_GCTP_SPHERE               -96
#define ERROR_GCTP_EQLAT                -97
#define ERROR_GCTP_BADZONE              -98
#define ERROR_GCTP_SPPAR                -99
#define ERROR_GCTP_BADCODE              -100
#define ERROR_GCTP_MISPAR               -101
#define ERROR_INPUT_WINDOW              -102
#define ERROR_OUTPUT_WINDOW             -103
